package Vulture;
our $VERSION = '1.0';

BEGIN {
    use Exporter ();
    @ISA = qw(Exporter);
    @EXPORT_OK = qw($proto &get_app $proxy_name $auth_url &session &get_cookie &read_conf &init $db_uri $path);
}

use strict;
use warnings;

use Apache::Session::Generate::MD5;
use Apache::Session::Flex;
use DBI;

our ($proto, $proxy_name, $auth_url, $db_uri, $conf, $path, $proxy_port, $proxy_proto);

sub	session {
	my ($session, $id) = @_;

	tie %$session,'Apache::Session::Flex',$id,{
						   Store => 'MySQL',
						   Lock  => 'Null',
						   Generate => 'MD5',
						   Serialize => 'Base64',
						   DataSource => 'dbi:SQLite2:dbname=/var/www/VultureNG/sql/sessions'
						  };
}

sub	get_cookie {
	my $cookie = shift;
	my $expression = shift;
	my $ret;

	return undef if !$cookie or !$expression;

	if (UNIVERSAL::isa($expression, "ARRAY")) {
		foreach ($expression) {
			if ($ret = get_cookie($cookie, $_)) {
				return $ret;
			}
		}
	}
	if (UNIVERSAL::isa($cookie, "ARRAY")) {
		foreach ($cookie) {
			if ($ret = get_cookie($_, $expression)) {
				return $ret;
			}
		}
	}

	($ret) = ($cookie =~ /$expression/);
	return $ret; 
}

sub	_get_app {
	my ($dbh, $row) = @_;

	return {
		'id'                    => @$row[0],
		'name'			=> @$row[1],
		'url'                   => @$row[3],
		'sso_forward_type'      => @$row[4],
		'is_post'               => @$row[5],
		'post_url'              => @$row[6],
		'auth'                  => @$row[7],
		'rewrite'               => @$row[8],
		'basic'                 => @$row[9],
		'auth_type'             => @$row[10],
		'up'	                => @$row[11]
	       };
}

sub	get_app {
	my ($host, $dbh, $intf) = @_;

	my $all = $dbh->selectall_arrayref("SELECT app.id, app.name, alias, url, sso_forward_type, is_post, post_url, auth, rewrite, basic, type, up".
					   " FROM app, auth, if WHERE app.auth=auth.id OR app.auth='0' AND app.if='$intf' AND if.id='$intf'");
	foreach my $row (@$all) {
		if (@$row[1] eq $host) {
			return _get_app($dbh, $row);
		}
	}
	foreach my $row (@$all) {
		foreach my $als (split (/,/, @$row[2])) {
			$als =~ s|\\\\|\\|g;
			if ($host =~ /$als/) {
				return _get_app($dbh, $row);
			}
		}
	}
}

sub	init {
	my %args = @_;

	$proto			= $args{proto};
	$proxy_name		= $args{proxy_name};
	$proxy_port		= $args{proxy_port};
	$proxy_proto		= $args{proxy_proto};
	$db_uri			= $args{db_uri};
	$path			= $args{path};

	$auth_url		= $proxy_proto."://".$proxy_name. ":". $proxy_port;
}

1;
