<?php
	
include_once "AbstractAction.php";
include_once "CA.php";
	
class editCA extends AbstractAction {
	
	function editCA() {
		parent::AbstractAction();
	}

	
	function execute($mapping, $form, &$request, &$response) {
	
		global $i18n, $rooster_ip, $rooster_port, $rooster_cert;
		parent::execute();
	
		$this->setForward('ko');

		$ca = new CA();
		$db = $this->getDS('MyDS');
		$ca->select($db, $form->getCAID());
		
		$request->setAttribute('acl', $form->getIsACL() ? $form->getIsACL() : $ca->getIsACL());

		if ($form->getIsACLSubmit() && $form->getACLOK() || $form->getACLKO()) {
			$ca->setACLOK($db, $form->getACLOK());
			$ca->setACLKO($db, $form->getACLKO());			
			$ca->update($db);
			$request->setAttribute('id', $ca->getID());
			$form->reset($request);
			$this->setForward('ko');
		}
		elseif ($form->getSubmit() && !$form->getErrors() && !$form->getIsACLSubmit()) {
			$ca->setName		($form->getCAName());
			$ca->setConstraint	($form->getCAConstraint());
			$ca->setCrt		($form->getCACrt());
			$ca->setRequire		($form->getCARequire());
			$ca->setIsACL		($form->getIsACL());
			
			if ($err = $ca->update($db)) {
				$form->addError('name', $error);
				$form->reset($request);
			}
			else {
				$this->setForward('ok');
				$request->setAttribute('errors', $form->getErrors());		
				return $this->getForward($mapping);
			}
		}

		elseif ($form->getErrors())
			$form->reset($request);

		else {
			$request->setAttribute('name', 		$ca->getName());
			$request->setAttribute('ssl_constraint',$ca->getConstraint());
			$request->setAttribute('crt', 		$ca->getCrt());
			$request->setAttribute('ca_require', 	$ca->getRequire());
			$request->setAttribute('id', 		$ca->getID());
		}

		if ($form->getIsACL() || $ca->getIsACL()) {
                        if ($rooster_ip && $rooster_port && $rooster_cert) {
                                $ca->setRoosterHost($rooster_ip);
                                $ca->setRoosterPort($rooster_port);
                                $ca->setRoosterCert($rooster_cert);
                                $result = $ca->send($db, "getRPCData");

                                $value = $result->value();
                                for ($i = 0; $i < $value->arraysize(); $i++) {
                                        $cert = $value->arraymem($i);
                                        $serial = $cert->structmem('SERIAL');
                                        $ca2 = $cert->structmem('CA');
                                        $dn = $cert->structmem('DN');
                                        $name = $cert->structmem('NAME');
                                        $rooster[] = array('SERIAL' => $serial->scalarval(),
                                                           'DN'    => $dn->scalarval(),
                                                           'NAME'  => $name->scalarval(),
                                                           'CA'    => $ca2->scalarval());
                                }
                        }

                        $query = "SELECT user_id FROM acl, auth WHERE auth.type=2 AND auth.id_auth=".sqlite_escape_string($ca->getID()).
                                " AND acl.auth_id=auth.id";
                        $result = $db->query($query);

                        while ($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
                                foreach ($rooster as $r) {
                                        if ($r['SERIAL'].";".$r['CA'] == $row['user_id']) {
                                                $acl_ok[] = $r;
                                                continue 2;
                                        }
                                }
                                $acl_ok[] = array('user_id' => $row['user_id']);
                        }
                        $request->setAttribute('acl_ok', $acl_ok);
                        if ($rooster_ip && $rooster_port && $rooster_cert) {

                                foreach ($rooster as $r) {
                                        foreach ($acl_ok as $ok) {
                                                if ($ok['SERIAL'] == $r['SERIAL']) {
                                                        continue 2;
                                                }
                                        }
                                        $acl_ko[] = $r;
                                }
                                $request->setAttribute('acl_ko', $acl_ko);
                        }

                }
		
		$request->setAttribute('errors', $form->getErrors());
		
		return $this->getForward($mapping);
	}

}
	
?>
